<script setup lang="ts">
import { usePromotionStore } from '@/stores/promotion'
import { useProductStore } from '@/stores/product';
import { computed, ref, watch } from 'vue'
import type { VForm } from 'vuetify/components'
const textValidate = ref('')
const refform = ref<VForm | null>(null)
const promoStore = usePromotionStore()
const loading = ref(false)
const currentDate = new Date()
const productStore = useProductStore()

const productName = ref<string[]>([])
for (let index = 0; index < productStore.products.length; index++) {
  productName.value.push(productStore.products[index].name)
  
}


const validatePositiveInteger = (v: number) => {
  if (v === null) return 'Field is required '
  const num = Number(v)
  return (
    (Number.isFinite(num) && num > 0 && num < 50) || 'A Number must be more than 0 and less than 1'
  )
}

const validatePositiveUnit = (v:string) => {
  if (v === null) return 'Field is required '
}

async function save() {
  let { valid } = await refform.value!.validate()
  if (!valid) return
  promoStore.save()
  promoStore.product = ''
  promoStore.dialogType2 = false
}

watch(['promoStore.editedPromotion.start', 'promoStore.editedPromotion.end'], checkDateRange)

function checkDateRange() {
  const startDate = new Date(promoStore.editedPromotion.start)
  const endDate = new Date(promoStore.editedPromotion.end)
  const startMonth = startDate.getMonth()
  const endMonth = endDate.getMonth()
  // ดูว่ามันได้รับข้อมูลเข้าไหม  
  console.log('Start Date:', startDate)
  console.log('End Date:', endDate)
  console.log('Start Month:', startMonth)
  console.log('End Month:', endMonth)

  promoStore.editedPromotion.status = currentDate >= startDate && currentDate <= endDate
  console.log('Status:', promoStore.editedPromotion.status)

  return promoStore.editedPromotion.status
}

function condition() {
  promoStore.editedPromotion.product = promoStore.product
  promoStore.editedPromotion.con = ` ${
    promoStore.editedPromotion.product
  } ลดราคาเหลือ ${promoStore.editedPromotion.discount} บาท`
  promoStore.editedPromotion.product = promoStore.product
}

function isEnddateValid(endDate:Date){
  return new Date(endDate) > new Date(promoStore.editedPromotion.start) || 'End date must be after Start date';
}
function findProductToSetPrice(){
  for (const i of productStore.products) {
    if(i.name === promoStore.product){
      console.log(promoStore.product);
      promoStore.editedPromotion.price = i.price
      return
    }else{
      promoStore.editedPromotion.price = 0
    }
  }
}
function findProudct(){
  for (const i of productStore.products) {
    if(i.name === promoStore.product){
      promoStore.editedPromotion.price = i.price - promoStore.editedPromotion.discount
      return
    }else{
      promoStore.editedPromotion.price = 0
    }
  }
}
function closeDialog(){
  promoStore.cleardialog()
  promoStore.dialogType2 = false
}
</script>
<template>
  <v-dialog v-model="promoStore.dialogType2" persistent width="500">
    <v-card>
      <v-card-title>
        <span class="text-h5">Add Promotion</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refform" v-model="promoStore.form">
          <v-container>
            <v-row>
              <v-col cols="12" md="12">
                <v-text-field
                  v-model="promoStore.editedPromotion.name"
                  :rules="[(v) => !!v || 'Please enter name.']"
                  clearable
                  label="Name"
                  placeholder="Enter Promotion name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="promoStore.editedPromotion.start"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please enter start date.']"
                  clearable
                  label="Start Date"
                  type="date"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="promoStore.editedPromotion.end"
                  :readonly="loading"
                  :rules="[isEnddateValid || 'Please enter end date.']"
                  clearable
                  label="End Date"
                  type="date"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-combobox label="Product" :items="productName" v-model="promoStore.product" @keyup.enter="findProductToSetPrice()"></v-combobox>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="promoStore.editedPromotion.discount"
                  :readonly="loading"
                  :rules="[validatePositiveInteger]"
                  clearable
                  persistent-hint
                  label="Discount"
                  type="number"
                  @click:append-inner="findProudct()"
                  @keyup.enter ="findProudct()"
                ></v-text-field>
              </v-col>
              
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="promoStore.editedPromotion.price"
                  :readonly="loading"
                  clearable
                  persistent-hint
                  label="New Price"
                  type="number"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>{{ textValidate }}</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save(), checkDateRange(), condition(),promoStore.dialogType = false">
          Save
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
